// Soubor POLE1.CPP
// Priklad tridy obsahujici dynamicky alokovane pole
// kopirovaci konstruktor a destruktor
// Verze 1 - nic moc: chybi prirazovaci operator,
// delka pole je deklarovana pomoci globalni konstanty

// Vzhledem k rozdilum v chovani prekladacu
// zde nekontrolujeme, zda se alokace podarila,
// takze priklad lze prelozit i starsimi prekladaci

const int N = 10;		// Delka pole
class pole {
	int *p;
public:
	explicit pole(int d=0);
	pole(pole&);		// kopirovaci konstruktor
	int &prvek(int i) { return p[i]; }
	~pole() { delete p;}	// destruktor
};

pole::pole(int d)
{
	p = new int [N];
	for(int i = 0; i < N; i++)
		p[i] = d;
}

pole::pole(pole& P)
{
	p = new int[N];
	for(int i = 0; i < N; i++) p[i] = P.p[i];
}

void main()
{
  pole P(0);
  P.prvek(1) = 56;
  pole Q(P);
}