// Soubor POLE2.CPP
// Priklad dynamicky alokovaneho pole

// Verze 2: delka pole je popsana vyctovym typem 
// deklarovanym uvnitr tridy pole

// Vzhledem k rozdilum v chovani prekladacu
// zde nekontrolujeme, zda se alokace podarila, stejne jako
// ve verzi 1

class pole {
	enum {delka = 10};
	int *p;
public:
	explicit pole(int d=0);
	pole(pole&);
	int &prvek(int i) { return p[i]; }
	~pole() { delete p;}
};

pole::pole(int d)			// Konstruktor alokuje [delka] prvku
{
	p = new int [delka];
	for(int i = 0; i < delka; i++)	// a vyplni je hodnotou d
		p[i] = d;
}

pole::pole(pole& P)			// Kopirovaci konstruktor udela hlubokou kopii
{
	p = new int[dekla];
	for(int i = 0; i < delka; i++) p[i] = P.p[i];
}

void main()
{
  pole P(0);
  P.prvek(1) = 56; 
//  P.prvek(pole::delka - 1) = 45; // chyba - vyctova konstanta pole::delka je soukroma
  pole Q(P);
}