// Soubor GENER.CPP
// Priklad na pretizeny operator volani funkce ()
//
// Generator pseudonahodnych cisel v rozmezi 0 .. limit-1
// Pretizeny operator () vraci pseudonahodne cislo
//
// Chceme-li pouzit jiny generator, muzeme od teto tridy odvodit potomka
// Metoda operator() je virtualni, takze k problemum nedojde

#include <iostream.h>
#include <limits.h>
#include <stdlib.h>

class generator {
	int limit;
public:
	void NastavMez(long mez) {limit = mez;}
	generator(int mez = INT_MAX):limit(mez) {}
	virtual int operator()();
};

int generator::operator ()(void)
{
	return rand() % limit;		// Pouzijeme standardni generator 
}


generator G6(6);			// Instance: generator nahodnych celych cisel v rozmezi 0 .. 5

void main()
{
  for(int i = 0; i < 10; i++) cout << G6() << endl; // Nejake pouziti
}
