// Soubor POLE4.CPP
// Priklad pretizeneho prirazovaciho operatoru 
// Jde o rozsireni prikladu ze souboru POLE3.CPP

// Instance tridy pole dosud neslo rozumne prirazovat - vytvarela se pouze melka kopie
// a navic se pritom ztracela pamet
// proto pro tuto tridu pretizime prirazovaci operator

// Vzhledem k rozdilum v chovani prekladacu
// zde nekontrolujeme, zda se alokace podarila, stejne jako
// v predchozich verzich

class pole {
	int *p;
public:
	enum {delka = 10};
	explicit pole(int d=0);
	pole(pole&);
	int& operator[](int);
	~pole() { delete p;}
	pole& operator=(pole& p);
};

pole& pole::operator=(pole& P)   // Pretizeny operator =
{
	for(int i = 0; i < delka; i++) p[i] = P.p[i];
	return *this;	// Zde vraci odkaz na levy operand
}

pole::pole(int d)
{
	p = new int [delka];
	for(int i = 0; i < delka; i++)
		p[i] = d;
}

pole::pole(pole& P)
{
	p = new int[delka];
	for(int i = 0; i < delka; i++) p[i] = P.p[i];
}

int& pole::operator [](int index)
{
	return p[index];
}

void main()
{
  pole P(0);
  for(int i = 0; i < pole::delka; i++)
	  P[i] = 10;
  pole Q(0);
  Q = P;	// Pouzijeme pretizeny prirazovaci operator
 // .....
}