// Soubor T_MAX.CPP
// Uvodni priklad deklarace sablony: 
// Sablona funkce MAX, ktera vypocte vetsi ze dvou hodnot.
#include <iostream.h>

// Definice sablony
template<class T> T MAX(T a, T b)
{
	return a > b? a : b;
};

// Trida, pro kterou je definovan operator >
class Int {
	int i;
public:
	Int(int j):i(j){}
	int hodnota(){ return i;}
	friend bool operator>(Int a, Int b);
};

bool operator>(Int a, Int b)
{
	return a.i > b.i;
}

void main()
{
	int a = 11, b = 22;
	char alfa('a'), beta('b'); // znamena totez jako  char alfa = 'a', beta ='b';
	Int x(5), y(6);
	// Pouziti sablony: Prekladac automaticky vytvori instance
	// sablony Max, tj. funkce 
	// int MAX(int, int), char MAX(char, char) a Int MAX(Int, Int)
	cout << MAX(a, b) << endl;
	cout << MAX(alfa, beta) << endl;
	cout << MAX(x, y).hodnota() << endl;
	// To nejde - prekladac nevi, co s tim:
	// cout << MAX(a, beta);

	// Musime prekladaci napovedet, jakou instanci vlastne chceme:
	// (Ani to nemusi ve starsich prekladacich fungovat.)
	cout << MAX<int>(a, beta);
}	