// Soubor T_VNOR2.CPP
// Priklad na vnorene sablony
// Prelozeno v Borland C++ Builderu 4.0, 
// starsi verze a MS Visual C++ 6 to neprelozi
//
// Trida ptr<T> obsahuje ukazatel p na instanci tridy T a
// operator pretypovani ptr<R>
//
// Tento operator pretypovani proste zavola konstruktor 
// tridy ptr<R> a preda mu jako parametr ukazatel p

#pragma hdrstop
#include <condefs.h>

template <class T> class ptr
{
        T* p;
public:
        ptr(T*p): p(p){}
        T* pointer() {return p; }
        template<class R> operator ptr<R>();
};

template<class T> template<class R>
ptr<T>::operator ptr<R>() {return ptr<R>(p); }

class A {public: int a;};
class B: public A {public: int b;};

int main(int argc, char* argv[])
{
        A a;
        ptr<B> p = new B;
        ptr<A> q = (ptr<A>)p;
        return 0;
}
