// Soubor NSP1.CPP
// Soubor NSP1.CPP
// Uvodni priklad k prostorum jmen
//
// Program ukazuje deklaraci pojmenovaneho prostoru jmen,
// pouziti globalnich promennych v prostoru jmen a mimo ne
// a definici funkce z prostoru jmen mimo tento prostor jmen

#include <iostream>

// Globalni promenne a funkce definovane mimo prostor jmen
int i = 5;
void f()
{
	std::cout << "Globalni funkce" << std::endl;
}

namespace Prvni {
	// Promenna a funkce v prostoru jmen
	int i = 22;
	void f();
}

// Funkci muzeme definovat i mimo prostor jmen, 
// staci, ze je v prostoru jmen deklarace
void Prvni::f(){
	// Telo teto funkce je soucasti prostoru jmen Prvni
	// Objekt z jineho prostoru jmen (napr. cout) je treba kvalifikovat
	// objekty z prostoru jmen Prvni nikoli:
	// zde uvedene i bez kvalifikace odkazuje na Prvni::i
	// Globalni jmeno lze pouzit pomoci unarniho operatoru ::,
	// takze ::i je globalni i
	std::cout << "Funkce v prostoru Prvni: " << "i*::i = " << i*::i << std::endl;
}

int main()
{
	int i = 555;
	std::cout 	<< "lokalni i = " << i << std::endl;
	std::cout 	<< "Prvni::n = "
					<< Prvni::i << std::endl;
	std::cout 	<< "globalni i = " << ::i << std::endl;
	f();
	Prvni::f();
	return 0;
}
