// Soubor IO4.CPP
// Prace s binarnim souborem
// Pouzijeme proud fstream, ve kterem pri otevreni zadame
// rezim ios|binary
//
// K zapisu do souboru pouzijeme metodu write, ke cteni metodu read
#include <iostream>
#include <fstream>
#include <stdlib.h>

using namespace std;

const char* jmeno = "data.dta";

void Chyba()
{
	cerr << "nepodarilo se otevrit soubor " << jmeno << endl;
	exit(1);
}

void main()
{
	fstream F(jmeno, ios::out | ios::binary);
	if(!F) Chyba();						// Pokud se soubor nepodarilo otevrit...
	for(int j = 0; j < 10; j++)
		F.write((char*)&j, sizeof(j));
	F.close();
	
	// Ke znovuotevreni proudu pouzijeme metodu open, ktera ma parametry stejme jako konstruktor tridy fstream.
	F.open(jmeno, ios::in | ios::binary);
	int i;
	while(F.read((char*)&i, sizeof(i)))
	{
		cout << i << endl;
	}
}