// Soubor IMPLIC.CPP
// Priklad implicitnich hodnot parametru
// 
// Funkce tisk ma jediny parametr typu int a ten ma
// implicitni hodnotu x
//
// Jiz v dobe prekladu se vyhodnoti, ze jde o globalni x
// nebot to je videt v miste definice funkce tisk. Pouzije se ovsem hodnota
// promenne x v okamziku volani, tedy 2.7182...
//
// Proto se pri volani teto funkce bez parametru pouzije 
// globalni x, nikoli x lokalni ve funkci main(),
// takze tento program vytiskne 2 (novou hodnotu x po konverzi na typ int)

#include <stdio.h>
double x = 3.14;

void tisk(int a = x)
{
	printf("%d\n", a);
}

int main()
{
	int x = 15;
	::x = 2.7181818; 	// Zmenime globalni x
	tisk();
	return 0;
}
