// Soubor DEDIC5.CPP
// Dedeni a prirazovani

#include <iostream.h>

class A {	// Jeden predek
	int a;
public:
	A(int aa):a(aa){}
	virtual void f(){cout << "A" << endl;}
};

class B {	// Druhy predek
    int b;
public:
	B(int bb) : b(bb){}
};

class C: public A, public B	// Spolecny potomek 
{
	int c;
public:
	C(int a, int b, int c): A(a), B(b), c(c) {}
	virtual void f(){cout << "C" << endl;}
};

void Fun(A a)
{
	a.f();
}

void main()
{
	A aa(1);
	B bb(2);
	C cc(4,5,6);
	aa = cc; // Prenese se pouze 
	Fun(cc); // preda se A, takze vypise "A"
}
