// Soubor NEW1.CPP
// Priklad predefinovani operatoru new
// Zde definovane operatory new a delete nahradi standardni operatory
// a to od pocatku behu programu

// Operator new navic vyplni vsechny bajty pridelene pameti hodnotou 0xFF,
// (vsechny bity obsahuji 1)
// Operator new by mel navic vracet pro kazdy objekt jinou adresu, 
// a to i v pripade, ze bude pozadovana velikost 0 bajtu; 
// proto vraci vzdy alespon  bajt
// Operator delete vypise adresu uvolnovaneho objektu 

#include <stdlib.h>
#include <string.h>
#include <stdio.h>

void * operator new(size_t s)
{
	if(!s) s = 1;				// Vrat vzdy alespon 1 bajt
	void *p = malloc(s);		// alokuj pamet
	if(p) memset(p, 0xFF, s);	// vypln ji jednickami
	return p;					// Vrat jeji adresu
}


void operator delete(void* p)
{
	printf("uvolnuji objekt na adrese %p\n", p);
	if(p) free(p);
}

void main()
{
	int *ui = new int;
	delete ui;
}