// Soubor POLE3.CPP
// Priklad pretizeneho operatoru indexovani
// Jde o rozsireni prikladu ze souboru POLE2.CPP

// Zmeny: 
// - nepojmenovany vyctovy typ je verejny, abychom mohli pouzivat
//   konstantu delka i mimo tridu
// - metodu Prvek() nahradil pretizeny operator []


// Vzhledem k rozdilum v chovani prekladacu
// zde nekontrolujeme, zda se alokace podarila, stejne jako
// v predchozich verzich

class pole {
	int *p;
public:
	enum {delka = 10};
	explicit pole(int d=0);
	pole(pole&);
	int& operator[](int);
	~pole() { delete p;}
};

pole::pole(int d)
{
	p = new int [delka];
	for(int i = 0; i < delka; i++)
		p[i] = d;
}

pole::pole(pole& P)
{
	p = new int[delka];
	for(int i = 0; i < delka; i++) p[i] = P.p[i];
}

int& pole::operator [](int index)
{
	return p[index];
}

void main()
{
  pole P(0);
  for(int i = 0; i < pole::delka; i++) // Nyni muzeme pouzit pole::delka, nebot tento typ je verejny
	  P[i] = 10;
  pole Q(P);
}