// Soubor NSP2.CPP
// Vnoreny prostor jmen
// Program obsahuje prostor jmen Vnejsi a do nej vnoreny prostor jmen Vnoreny
//
// Pouzijeme-li identifikator z vnitrniho prostoru jmen 
// - ve vnitrnim prostoru, nemusime ho kvalifikovat
// - ve vnejsim prostoru, staci ho kvalifikovat jmenem vnitrniho prostoru,
// - kdekoli jinde, musime ho kvalifikovat jmenem vnitrniho i vnejsiho prostoru

#include <iostream>
#include<string>

namespace Vnejsi {
	std::string Text = "Vnejsi";
	void Tiskni(){std::cout << Text << std::endl;}
	namespace Vnoreny {			// Vnoreny prostor jmen
		std::string Text = "Vnejsi::Vnoreny";
		void Tiskni(){std::cout << Text << std::endl;}
	}							// Konec vnoreneho prostoru jmen
	void JesteTiskni() { std::cout << Vnoreny::Text << std::endl;}
}

int main(){
	Vnejsi::Tiskni();
	Vnejsi::Vnoreny::Tiskni();
	Vnejsi::JesteTiskni();
	return 0;
}
