// Soubor IO11.CPP
// Priklad klasickych pametovych proudu pracujicich s polem znaku
//
// Konstruktor tridy ostrstream ma dva parametry - ukazatel pole znaku a
// delku tohoto pole
//
// Do tohoto pole zapisujeme pomoci operatoru << a vytvorime 
// tak v nem retezec, 
// Retezec ulozeny v poli c pak vypiseme.
//
// Vsimnete si rozdilu opreoti nove implementaci pracujici s tridou 
// string: Data v proudu jsou primo pristupna, proud pracuje primo se zadanym polem.

#include <strstrea.h>
#include <iostream.h>

char c[100];

void main()
{
	ostrstream S(c, sizeof(c));
	for(int i = 0; i < 10; i++)
		S << i << " ";
	S << ends;
	cout << c << endl;
}