// Soubor IO3.CPP
// Cteni celych cisel ze souboru nezname velikosti
// Pouzijeme proud ifstream (konstruktor ma sice 3 parametry, 
// musime ale zadat pouze prvni - jmeno souboru).
//
// K testovani pouzijeme pretizeny operator pretypovani na void*,
// ktery vrati 0, kdyz se posledni operace nepodari

#include <iostream>
#include <fstream>
#include <stdlib.h>

using namespace std;

const char* jmeno = "data.dta";

void Chyba()
{
	cerr << "nepodarilo se otevrit soubor " << jmeno << endl;
	exit(1);
}

void main()
{
	ofstream F(jmeno);
	if(F)	{									// Pokud se soubor podarilo otevrit...
		for(int j = 0; j < 10; i++)
			F << j << "  " << endl<< endl;		
		F.close();
	}
	else Chyba();

	ifstream G(jmeno);
	int i;
	while(G >> i)
	{
		cout << i << endl;
	}
}